/* Programme de test ping de serveur hlds counter strike
   Avril 2005

   Franois Boisson
*/

#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <time.h>

#define PORT 27015


struct sockaddr_in desc_douille;
int verbeux = 0;

void erreur(message)
char *message;
{
  if (verbeux) {
    printf("Erreur %s\n",message);
    perror("Message d'erreur: ");
  }
  exit(1);
}



int cree_douille_udp (broadcast)
  int broadcast;
{
  int sock;

  if ((sock = socket (AF_INET, SOCK_DGRAM, 0)) < 0) {
    erreur ("cration douille");
    return (-1);
  }
  setsockopt(sock,SOL_SOCKET,SO_BROADCAST, &broadcast,sizeof(broadcast));
  return (sock);
}

void ausecours()
{
  printf("pinghlds [-a destination] [-p port] [-v] [-h] [-n nombre] [destination]\n");
  printf("Ping d'un serveur HLDS Counter Strike, port par dfaut: 27015\n");
  printf("nombre est le nombre de paquets envoys (dfaut 10)\n");
  exit(2);
}


main(argc,argv)
int argc;
char **argv;
{
  int douille,i,j;
  char buffer[256];
  double temps,tempst; 
  struct sockaddr_in adresse;
  struct sockaddr_in adresser;
  struct hostent *   hostent  = NULL;
  struct servent *   servent  = NULL;
  struct protoent *  protoent = NULL;
  int nombre = 10;
  char *hote = NULL;
  int prt = PORT;
  int option;
  while ((option = getopt(argc,argv,"n:p:a:vh")) != -1) {
    switch(option) {
    case 'a':
      hote = optarg;
      break;
    case 'p':
      sscanf(optarg,"%d",&prt);
      break;
    case 'n':
      sscanf(optarg,"%d",&nombre);
      break;
    case 'v':
      verbeux = 1;
      break;
    case 'h':
    case '?':
    default:
      ausecours(); 
      break;
    }
  }
  if ((hote == NULL) && (optind < argc)) hote = argv[optind];
  if (hote == NULL) ausecours();
  douille = cree_douille_udp(1);

  if (hote != NULL)
    if ((hostent = gethostbyname (hote)) == NULL) {
      erreur ("gethostbyname");
      return (-1);
    }
  
  if ((protoent = getprotobyname ("udp")) == NULL) {
    erreur ("getprotobyname");
    return (-1);
  }


  memset (& adresse, 0, sizeof (struct sockaddr_in));
  adresse . sin_family = AF_INET;
  if (prt != 0) adresse.sin_port = htons(prt);
  else adresse . sin_port = htons (0);
  if (hostent != NULL)
    adresse . sin_addr . s_addr =
      ((struct in_addr *) (hostent -> h_addr)) -> s_addr;
  else erreur("pas de destinataire");
  i =  sizeof (struct sockaddr_in);
  tempst = 0.0;
  for(j=1;j<=nombre;j++) {
  temps=times(NULL);
  sendto(douille,"\x0ff\x0ff\x0ff\x0ffping",8,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));
  recvfrom(douille,buffer,6,0,(struct sockaddr *) & adresser,
	    &i);
  temps=(times(NULL)-temps)*10000000/CLOCKS_PER_SEC/nombre;
  tempst=tempst+temps;
}
  close(douille);
  printf("Ping de %f ms\n",tempst);
  exit(0);
}


