#include <mysql/mysql.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <time.h>
#include <pwd.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <signal.h>
#include <malloc.h>

#define DEBUG 0

#define ARMES "armes"
#define SCORES "scores"
#define PSEUDOS "pseudos"



/*
CREATE TABLE scores (
steam_id varchar(20) NOT NULL,
pseudo varchar(36),
arme varchar(10),
tirs int,
impacts int,
tues int,
hs int,
tks int,
dmgs int,
morts int);

alter table scores add index (steam_id);


CREATE TABLE armes (
steam_id varchar(20) NOT NULL,
pseudo varchar(36),      
arme varchar(10),
tete int,
poitrine int,
ventre int,
bgche int,
bdt int,
jmbgche int,
jmbdte int);

alter table armes add index(steam_id);

CREATE TABLE pseudos (
pseudo varchar(36) NOT NULL,
 steam_id varchar(20));

alter table pseudos add index(pseudo);

+--------------------+
| Tables_in_rconhlds |
+--------------------+
| armes              |
| pseudos            |
| scores             |
+--------------------+
mysql> describe armes;
+----------+-------------+------+-----+---------+-------+
| Field    | Type        | Null | Key | Default | Extra |
+----------+-------------+------+-----+---------+-------+
| steam_id | varchar(20) |      | PRI |         |       |
| pseudo   | varchar(36) | YES  |     | NULL    |       |
| arme     | varchar(10) | YES  |     | NULL    |       |
| tete     | int(11)     | YES  |     | NULL    |       |
| poitrine | int(11)     | YES  |     | NULL    |       |
| ventre   | int(11)     | YES  |     | NULL    |       |
| bgche    | int(11)     | YES  |     | NULL    |       |
| bdt      | int(11)     | YES  |     | NULL    |       |
| jmbgche  | int(11)     | YES  |     | NULL    |       |
| jmbdte   | int(11)     | YES  |     | NULL    |       |
+----------+-------------+------+-----+---------+-------+
mysql> describe pseudos;
+----------+-------------+------+-----+---------+-------+
| Field    | Type        | Null | Key | Default | Extra |
+----------+-------------+------+-----+---------+-------+
| pseudo   | varchar(36) |      | PRI |         |       |
| steam_id | varchar(20) | YES  |     | NULL    |       |
+----------+-------------+------+-----+---------+-------+
mysql> describe scores;
+----------+-------------+------+-----+---------+-------+
| Field    | Type        | Null | Key | Default | Extra |
+----------+-------------+------+-----+---------+-------+
| steam_id | varchar(20) |      | MUL |         |       |
| pseudo   | varchar(36) | YES  |     | NULL    |       |
| arme     | varchar(10) | YES  |     | NULL    |       |
| tirs     | int(11)     | YES  |     | NULL    |       |
| impacts  | int(11)     | YES  |     | NULL    |       |
| tues     | int(11)     | YES  |     | NULL    |       |
| hs       | int(11)     | YES  |     | NULL    |       |
| tks      | int(11)     | YES  |     | NULL    |       |
| dmgs     | int(11)     | YES  |     | NULL    |       |
| morts    | int(11)     | YES  |     | NULL    |       |
+----------+-------------+------+-----+---------+-------+
*/

MYSQL base;
#define LMAX 2048
char requete[LMAX];


#define DEBUTE(x)   ou=assemble_requete(x,0)
#define RAJOUTE(x)   ou=assemble_requete(x,ou)
#define LETSGO(err) if(mysql_real_query(&base,requete,ou)!=0) return(err)


/* double emploi, bravo l'artiste!, tant pis je laisse */

char *inttostring(n,p,resultat)
     int n,p;
     char *resultat;
{
  int i,s;
  if (n <0) {s=-1;n=-n;} else s=1;
  resultat[--p] = 0;
  if (n==0) resultat[--p]='0';
  else
    do {
      resultat[--p] = (n % 10) + '0';
      n = n/10;
    } while (n >0);
  if (s<0) resultat[--p]='-';
  for (i=0;(resultat[i+p]!=0);i++) resultat[i]=resultat[i+p];
  resultat[i]=0;
}


int base_init()
{
  if (mysql_init(&base) == NULL) return(-1);
}

int base_close()
{
  mysql_close(&base);
}

int base_connect(passwd,user)
     char *passwd,*user;
{
  if (mysql_real_connect(&base,NULL, user,passwd,"rconhlds",0,NULL,0) == NULL)
    return(-1);
  return(0);
}


int assemble_requete(rajout,ou)
char *rajout;
int ou;
{
  int i;
  i=0;
  while ((rajout[i]!=0) &&(ou+i < LMAX)) {requete[ou+i]=rajout[i];i++;}
  return(ou+i);
}


int lock(table)
     char *table;
{
  int ou;
  DEBUTE("LOCK TABLES ");
  RAJOUTE(table);
  RAJOUTE(" WRITE");
  return(mysql_real_query(&base,requete,ou));
}

int unlock()
{
  return(mysql_real_query(&base,"UNLOCK TABLES",13));
}


int existe(steam_id,pseudo,table)
     char *steam_id,*pseudo,*table;
{
  int res,ou;
  MYSQL_RES *res_requete;     
  DEBUTE("SELECT steam_id FROM ");
  RAJOUTE(table);
  RAJOUTE(" WHERE steam_id=\"");
  RAJOUTE(steam_id);
  RAJOUTE("\" AND pseudo=\"");
  RAJOUTE(pseudo);
  RAJOUTE("\"");
  if((mysql_real_query(&base,requete,ou)!=0) && (DEBUG==1))
    {
      printf("Erreur %d renvoye, hmm\n");
    }
  res=0;
  if (DEBUG==1) printf("requete faite\n");
  if(res_requete=mysql_store_result(&base)) 
    if (res_requete) 
      {
	res=mysql_num_rows(res_requete);
	if (DEBUG==1) printf("A priori %d trouv\n",res);
	mysql_free_result(res_requete);
      }
  return(res);
}

int existe3(steam_id,pseudo,arme,table)
     char *steam_id,*pseudo,*arme,*table;
{
  int res,ou;
  MYSQL_RES *res_requete;     
  DEBUTE("SELECT steam_id FROM ");
  RAJOUTE(table);
  RAJOUTE(" WHERE steam_id=\"");
  RAJOUTE(steam_id);
  RAJOUTE("\" AND pseudo=\"");
  RAJOUTE(pseudo);
  RAJOUTE("\" AND arme=\"");
  RAJOUTE(arme);
  RAJOUTE("\"");
  if((mysql_real_query(&base,requete,ou)!=0) && (DEBUG==1))
    {
      printf("Erreur %d renvoye, hmm\n");
    }
  res=0;
  if (DEBUG==1) printf("requete faite\n");
  if(res_requete=mysql_store_result(&base)) 
    if (res_requete) 
      {
	res=mysql_num_rows(res_requete);
	if (DEBUG==1) printf("A priori %d trouv\n",res);
	mysql_free_result(res_requete);
      }
  return(res);
}


/* Mise  jour de la table pseudo */

int update_pseudo(steam_id,pseudo)
     char *pseudo,*steam_id;
{
  int ou,res;
  if (DEBUG==1) printf("Recherche %s,%s dans pseudos\n",steam_id,pseudo);
  if(existe(steam_id,pseudo,PSEUDOS) >0) 
    {
      if (DEBUG==1) printf("Trouv\n");
      return(0);
    }
  /* le couple pseudo/steam_id n'y est pas*/
  if (DEBUG==1) printf("Insertion %s,%s dans pseudos\n",steam_id,pseudo);
  lock(PSEUDOS);
  DEBUTE("INSERT INTO ");
  RAJOUTE(PSEUDOS);
  RAJOUTE(" (pseudo, steam_id ) VALUES (\"");
  RAJOUTE(pseudo);
  RAJOUTE("\",\"");
  RAJOUTE(steam_id);
  RAJOUTE("\")");
  res=mysql_real_query(&base,requete,ou);
  unlock();
  return(res);
}

/* mise  jour de la table score */

int update_scores(steam_id,pseudo,arme,tirs,impacts,tues,hs,tks,dmgs,morts)
     char *steam_id,*pseudo,*arme;
     int tirs,impacts,tues,hs,tks,dmgs,morts;
{
  int i,ou,res;
  MYSQL_RES *res_requete;     
  MYSQL_ROW ligne;
  char str_tirs[]="01234567890123456";
  char str_impacts[]="01234567890123456";
  char str_tues[]="01234567890123456";
  char str_hs[]="01234567890123456";
  char str_tks[]="01234567890123456";
  char str_dmgs[]="01234567890123456";
  char str_morts[]="01234567890123456";
  
  if(existe3(steam_id,pseudo,arme,SCORES) >0)
    {
      if (DEBUG ==1) printf("Scores trouv\n");
      /* il faut juste mettre  jour */
      /* 1) Recherche de la ligne */
      DEBUTE("SELECT tirs,impacts,tues,hs,tks,dmgs,morts FROM ");
      RAJOUTE(SCORES);
      RAJOUTE(" WHERE steam_id=\"");
      RAJOUTE(steam_id);
      RAJOUTE("\" AND pseudo=\"");
      RAJOUTE(pseudo);
      RAJOUTE("\" AND arme=\"");
      RAJOUTE(arme);
      RAJOUTE("\"");

      if((mysql_real_query(&base,requete,ou)!=0) && (DEBUG==1))
	{
	  printf("Erreur %d renvoye, hmm\n");
	}
      
      /* 2) lecture du rsultats */
      res_requete = mysql_store_result(&base);
      ligne = mysql_fetch_row(res_requete);
      if (DEBUG ==1) printf("Scores chargs\n");
      i=0;
      if (DEBUG == 1)
	printf("%s, %s ,%s, %s, %s, %s, %s\n",ligne[0],ligne[1],ligne[2],ligne[3],ligne[4],ligne[5],ligne[6]);
      tirs += atoi((ligne[i++]));
      impacts += atoi((ligne[i++]));
      tues += atoi((ligne[i++]));
      hs += atoi((ligne[i++]));
      tks += atoi((ligne[i++]));
      dmgs += atoi((ligne[i++]));
      morts += atoi((ligne[i++]));
      if (DEBUG ==1) printf("Scores additionns %d,%d,%d,%d,%d,%d\n",tirs,impacts,tues,hs,tks,morts);
      mysql_free_result(res_requete);
      inttostring(tirs,16,str_tirs);
      inttostring(impacts,16,str_impacts);
      inttostring(tues,16,str_tues);
      inttostring(hs,16,str_hs);
      inttostring(tks,16,str_tks);
      inttostring(dmgs,16,str_dmgs);
      inttostring(morts,16,str_morts);
      if (DEBUG == 1) printf("final: %s, %s, %s, %s, %s, %s\n",str_tirs,str_impacts,str_tues,str_hs,str_tks,str_morts);
      lock(SCORES);
      DEBUTE("UPDATE ");
      RAJOUTE(SCORES);
      RAJOUTE(" SET ");
      RAJOUTE(" tirs=");RAJOUTE(str_tirs);RAJOUTE(",");
      RAJOUTE(" impacts=");RAJOUTE(str_impacts);RAJOUTE(",");
      RAJOUTE(" tues=");RAJOUTE(str_tues);RAJOUTE(",");
      RAJOUTE(" hs=");RAJOUTE(str_hs);RAJOUTE(",");
      RAJOUTE(" tks=");RAJOUTE(str_tks);RAJOUTE(",");
      RAJOUTE(" dmgs=");RAJOUTE(str_dmgs);RAJOUTE(",");
      RAJOUTE(" morts=");RAJOUTE(str_morts);
      RAJOUTE(" WHERE steam_id=\"");
      RAJOUTE(steam_id);
      RAJOUTE("\" AND pseudo=\"");
      RAJOUTE(pseudo);
      RAJOUTE("\" AND arme=\"");
      RAJOUTE(arme);
      RAJOUTE("\"");
      res=mysql_real_query(&base,requete,ou);
      unlock();
      return(res);
      
    }
  else /* ajout dans la table */
    {
      inttostring(tirs,16,str_tirs);
      inttostring(impacts,16,str_impacts);
      inttostring(tues,16,str_tues);
      inttostring(hs,16,str_hs);
      inttostring(tks,16,str_tks);
      inttostring(dmgs,16,str_dmgs);
      inttostring(morts,16,str_morts);
      lock(SCORES);
      DEBUTE("INSERT INTO ");
      RAJOUTE(SCORES);
      RAJOUTE(" (pseudo, steam_id ,arme,tirs,impacts,tues,hs,tks,dmgs,morts) VALUES (\"");
      RAJOUTE(pseudo);
      RAJOUTE("\",\"");
      RAJOUTE(steam_id);
      RAJOUTE("\",\"");
      RAJOUTE(arme);
      RAJOUTE("\",");
      RAJOUTE(str_tirs);
      RAJOUTE(",");
      RAJOUTE(str_impacts);
      RAJOUTE(",");
      RAJOUTE(str_tues);
      RAJOUTE(",");
      RAJOUTE(str_hs);
      RAJOUTE(",");
      RAJOUTE(str_tks);
      RAJOUTE(",");
      RAJOUTE(str_dmgs);
      RAJOUTE(",");
      RAJOUTE(str_morts);
      RAJOUTE(")");
      res=mysql_real_query(&base,requete,ou);
      unlock();
      return(res);
    }
}

/* mise  jour de la table armes */

int update_armes(steam_id,pseudo,arme,tete,poitrine,ventre,bgche,bdt,jmbgche,jmbdte)
     char *steam_id,*pseudo,*arme;
     int tete,poitrine,ventre,bgche,bdt,jmbgche,jmbdte;
{
  int i,ou,res;
  MYSQL_RES *res_requete;     
  MYSQL_ROW ligne;
  char str_tete[]="01234567890123456";
  char str_poitrine[]="01234567890123456";
  char str_ventre[]="01234567890123456";
  char str_bgche[]="01234567890123456";
  char str_bdt[]="01234567890123456";
  char str_jmbgche[]="01234567890123456";
  char str_jmbdte[]="01234567890123456";

  if (DEBUG==1)  printf("Recherche du steam_di avec arme\n");
  if(existe3(steam_id,pseudo,arme,ARMES) >0)
    {
      if (DEBUG ==1) printf("Armes trouv\n");
      /* il faut juste mettre  jour */
      /* 1) Recherche de la ligne */
      DEBUTE("SELECT tete,poitrine,ventre,bgche,bdt,jmbgche,jmbdte FROM ");
      RAJOUTE(ARMES);
      RAJOUTE(" WHERE steam_id=\"");
      RAJOUTE(steam_id);
      RAJOUTE("\" AND pseudo=\"");
      RAJOUTE(pseudo);
      RAJOUTE("\" AND arme=\"");
      RAJOUTE(arme);
      RAJOUTE("\"");

      if((mysql_real_query(&base,requete,ou)!=0) && (DEBUG==1))
	{
	  printf("Erreur %d renvoye, hmm\n");
	}
      
      /* 2) lecture du rsultats */
      res_requete = mysql_store_result(&base);
      ligne = mysql_fetch_row(res_requete);
      if (DEBUG ==1) printf("Armes chargs\n");
      i=0;
      if (DEBUG == 1)
	printf("%s, %s ,%s, %s, %s, %s, %s\n",ligne[0],ligne[1],ligne[2],ligne[3],ligne[4],ligne[5],ligne[6]);
      tete += atoi((ligne[i++]));
      poitrine += atoi((ligne[i++]));
      ventre += atoi((ligne[i++]));
      bgche += atoi((ligne[i++]));
      bdt += atoi((ligne[i++]));
      jmbgche += atoi((ligne[i++]));
      jmbdte += atoi((ligne[i++]));
      if (DEBUG ==1) printf("Armes additionns %d,%d,%d,%d,%d,%d\n",tete,poitrine,ventre,bgche,bdt,jmbdte);
      mysql_free_result(res_requete);
      inttostring(tete,16,str_tete);
      inttostring(poitrine,16,str_poitrine);
      inttostring(ventre,16,str_ventre);
      inttostring(bgche,16,str_bgche);
      inttostring(bdt,16,str_bdt);
      inttostring(jmbgche,16,str_jmbgche);
      inttostring(jmbdte,16,str_jmbdte);
      if (DEBUG == 1) printf("final: %s, %s, %s, %s, %s, %s\n",str_tete,str_poitrine,str_ventre,str_bgche,str_bdt,str_jmbdte);
      lock(ARMES);
      DEBUTE("UPDATE ");
      RAJOUTE(ARMES);
      RAJOUTE(" SET ");
      RAJOUTE(" tete=");RAJOUTE(str_tete);RAJOUTE(",");
      RAJOUTE(" poitrine=");RAJOUTE(str_poitrine);RAJOUTE(",");
      RAJOUTE(" ventre=");RAJOUTE(str_ventre);RAJOUTE(",");
      RAJOUTE(" bgche=");RAJOUTE(str_bgche);RAJOUTE(",");
      RAJOUTE(" bdt=");RAJOUTE(str_bdt);RAJOUTE(",");
      RAJOUTE(" jmbgche=");RAJOUTE(str_jmbgche);RAJOUTE(",");
      RAJOUTE(" jmbdte=");RAJOUTE(str_jmbdte);
      RAJOUTE(" WHERE steam_id=\"");
      RAJOUTE(steam_id);
      RAJOUTE("\" AND pseudo=\"");
      RAJOUTE(pseudo);
      RAJOUTE("\" AND arme=\"");
      RAJOUTE(arme);
      RAJOUTE("\"");
      res=mysql_real_query(&base,requete,ou);
      unlock();
      return(res);
      
    }
  else /* ajout dans la table */
    {
      inttostring(tete,16,str_tete);
      inttostring(poitrine,16,str_poitrine);
      inttostring(ventre,16,str_ventre);
      inttostring(bgche,16,str_bgche);
      inttostring(bdt,16,str_bdt);
      inttostring(jmbgche,16,str_jmbgche);
      inttostring(jmbdte,16,str_jmbdte);
      if (DEBUG == 1) printf("final: %s, %s, %s, %s, %s, %s\n",str_tete,str_poitrine,str_ventre,str_bgche,str_bdt,str_jmbdte);
      if (DEBUG == 1) printf("final: %d, %d, %d, %d, %d, %d\n",tete,poitrine,ventre,bgche,bdt,jmbdte);
      lock(ARMES);
      DEBUTE("INSERT INTO ");
      RAJOUTE(ARMES);
      RAJOUTE(" (pseudo, steam_id ,arme,tete,poitrine,ventre,bgche,bdt,jmbgche,jmbdte) VALUES (\"");
      RAJOUTE(pseudo);
      RAJOUTE("\",\"");
      RAJOUTE(steam_id);
      RAJOUTE("\",\"");
      RAJOUTE(arme);
      RAJOUTE("\",");
      RAJOUTE(str_tete);
      RAJOUTE(",");
      RAJOUTE(str_poitrine);
      RAJOUTE(",");
      RAJOUTE(str_ventre);
      RAJOUTE(",");
      RAJOUTE(str_bgche);
      RAJOUTE(",");
      RAJOUTE(str_bdt);
      RAJOUTE(",");
      RAJOUTE(str_jmbgche);
      RAJOUTE(",");
      RAJOUTE(str_jmbdte);
      RAJOUTE(")");
      res=mysql_real_query(&base,requete,ou);
      unlock();
      return(res);
    }
}
