/* Programme de communication avec un serveur hlds counter strike
   Avril 2005

   Franois Boisson
*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <time.h>
#include <pwd.h>
#include <sys/ioctl.h>
#include <errno.h>

#define PORT 27015
#define TAILLE_PAQUET 1400
#define NBRE_PAQUETS 16
#define TMAX 0

char *desc_serveur=".rconhlds";

struct sockaddr_in desc_douille;
int verbeux = 0;

void erreur(message)
char *message;
{
  if (verbeux) {
    printf("Erreur %s\n",message);
    perror("Message d'erreur: ");
  }
  exit(1);
}



int cree_douille_udp (broadcast)
  int broadcast;
{
  int sock;

  if ((sock = socket (AF_INET, SOCK_DGRAM, 0)) < 0) {
    erreur ("cration douille");
    return (-1);
  }
  setsockopt(sock,SOL_SOCKET,SO_BROADCAST, &broadcast,sizeof(broadcast));
  return (sock);
}

void ausecours()
{
  printf("rconsole [-a destination] [-p port] [-w password] [-c commande]\n"); 
  printf("         [-v] [-h] [-t temps] commande\n");
  printf("Envoi de commande rcon sur un serveur HLDS Counter Strike.\n");
  printf("port par dfaut: 27015, lecture ventuelle des arguments dans ~/.rconhlds\n");
  printf("Typiquement: rconsole -a 82.66.248.156 -w mot_de_passe -p 27016 status\n");
  printf("\"temps\" est le temps d'attente des paquets UDP (dfaut 100000)\n");
  printf("\"temps\"=0 attend un seul paquet UDP, l'affiche et sort\n\n");
  printf("Franois Boisson Avril 2005\n");


  exit(2);
}


main(argc,argv)
int argc;
char **argv;
{
  int douille,i,j,k,l,n,nbp,e,tmax,attente;
  char buffer_total[TAILLE_PAQUET*NBRE_PAQUETS];
  char buffer[TAILLE_PAQUET];
  char challenge[32];
  char *pass = NULL;
  char *commande=NULL;
  char debut[]="challenge rcon";
  double temps,tempst; 
  struct sockaddr_in adresse;
  struct sockaddr_in adresser;
  struct hostent *   hostent  = NULL;
  struct servent *   servent  = NULL;
  struct protoent *  protoent = NULL;
  char *hote = NULL;
  FILE *fichier;
  int prt = PORT;
  int option;
  tmax=TMAX;
  chdir(getpwuid(getuid())->pw_dir);
  if ((fichier=fopen(desc_serveur,"r")) != NULL)
    {
      if (fgets(buffer,1024,fichier) != NULL) 
	{
	  hote = malloc(256);
	  for (i=0;(i<256) && (buffer[i]!=0);i++) hote[i]=buffer[i];
          i--;
          while ((hote[i] == '\r') || (hote[i] == '\n')) i--;
          hote[++i]=0;
	}
      fscanf(fichier,"%d\n",&prt);
      if (fgets(buffer,1024,fichier) != NULL) 
	{
	  pass = malloc(128);
	  for (i=0;(i<127) && (buffer[i]!=0);i++) pass[i]=buffer[i];
          i--;
          while ((pass[i] == '\r') || (pass[i] == '\n')) i--;
          pass[++i]=0;
	}
      fclose(fichier);
    }
  while ((option = getopt(argc,argv,"t:c:w:n:p:a:vh")) != -1) {
    switch(option) {
    case 'a':
      hote = optarg;
      break;
    case 'c':
      commande = optarg;
      break;
    case 'w':
      pass = optarg;
      break;
    case 'p':
      sscanf(optarg,"%d",&prt);
      break;
    case 't':
      sscanf(optarg,"%d",&tmax);
      break;
    case 'v':
      verbeux = 1;
      break;
    case 'h':
    case '?':
    default:
      ausecours(); 
      break;
    }
  }
  /*  printf("%d\n",tmax); */
  printf("Serveur %s:%d\n",hote,prt);
  if ((commande == NULL) && (optind < argc)) commande = argv[optind];
  if ((hote == NULL) || (commande == NULL) || (pass == NULL)) ausecours();
  douille = cree_douille_udp(1);

  if (hote != NULL)
    if ((hostent = gethostbyname (hote)) == NULL) {
      erreur ("gethostbyname");
      return (-1);
    }
  
  if ((protoent = getprotobyname ("udp")) == NULL) {
    erreur ("getprotobyname");
    return (-1);
  }


  memset (& adresse, 0, sizeof (struct sockaddr_in));
  adresse . sin_family = AF_INET;
  if (prt != 0) adresse.sin_port = htons(prt);
  else adresse . sin_port = htons (0);
  if (hostent != NULL)
    adresse . sin_addr . s_addr =
      ((struct in_addr *) (hostent -> h_addr)) -> s_addr;
  else erreur("pas de destinataire");
  i =  sizeof (struct sockaddr_in);
  tempst = 0.0;

  /* initialisation compteur temps */
  temps=times(NULL);

  /* envoi rcon */
  buffer[0]=buffer[1]=255;
  buffer[2]=buffer[3]=255;
  k=4;
  for (j=0;debut[j]!=0;j++) buffer[k++]=debut[j];
  buffer[k]=0;
  sendto(douille,buffer,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));

  l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,
	    &i);

  for (k=19;(k<l) && (buffer[k] !=10);k++) challenge[k-19]=buffer[k];

  challenge[k-19]=0;
  printf("Challenge: %s\n",challenge);

  /* preparation commande */
  buffer[0]=buffer[1]=255;
  buffer[2]=buffer[3]=255;
  k=4;
  buffer[k++]='r';
  buffer[k++]='c';
  buffer[k++]='o';
  buffer[k++]='n';
  buffer[k++]=' ';
  for (j=0;challenge[j]!=0;j++) buffer[k++]=challenge[j];
  buffer[k++]=' ';
  buffer[k++]='"';
  for (j=0;pass[j]!=0;j++) buffer[k++]=pass[j];
  buffer[k++]='"';
  buffer[k++]=' ';
  for (j=0;commande[j]!=0;j++) buffer[k++]=commande[j];

  sendto(douille,buffer,k,0,(struct sockaddr *) & adresse,
	    sizeof (struct sockaddr_in));
  

  /* reception commande */
  /* on passe la douille en non bloquant */
  e=1;
  if (tmax > 0) ioctl(douille,FIONBIO,&e);
  attente = tmax;
  do {
    e=0;
    do {
      l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,&i);}
    while ((l < 0) && (errno =EWOULDBLOCK) &&((attente--) >0));
    if (l >= 4) 
      {
	if (buffer[0]=255) 
	  {
	    /* un seul paquet */
	    buffer[l]=0;
	    printf("%s\n",buffer+5);
	  }
	else
	  /*plusieurs paquets */
	  {
	    nbp=(buffer[8]&15);
	    i = buffer[8]/16;
	    for (j=0;j<l-9;j++) buffer_total[i*(TAILLE_PAQUET-8)+j]=buffer[j];
	    n=l-9;
	    for (;nbp>0;nbp--)
	      {
		do {
		  attente=tmax;
		  l=recvfrom(douille,buffer,TAILLE_PAQUET,0,(struct sockaddr *) & adresser,&i);}
		while ((l < 0) && (errno =EWOULDBLOCK) &&((attente--) >0));

		i = buffer[8]/16;
		n+=(l-9);
		for (j=0;j<l-9;j++) buffer_total[i*(TAILLE_PAQUET-8)+j]=buffer[j];
	      }
	    buffer_total[l]=0;
	    printf("%s\n",buffer_total);
	    
	  }
	if (tmax > 0) e=1;
	attente=tmax;
      }
  } while (e == 1);
  temps=(times(NULL)-temps)*10000000/CLOCKS_PER_SEC;
  tempst=tempst+temps;

  close(douille);
  printf("Temps de la commande: %f ms\n",tempst);
  exit(0);
}


